// mcast2udp.c
#include "opensocks.h"

#define MAXSIZE 32768

int sock, snd_sock;

void clean_exit(clean)
{
   printf("exiting\n");
   cleanup(sock);
   cleanup(snd_sock);

   exit(0);
}

int main(int argc, char *argv[])
{
/* 
 * 
 * needed for CreateSocket
 * 
 */
   static char group[]="230.24.14.135";
   static char dest[]="10.1.1.1";
   char *grp;
   char *dst;
   int port=1042;

   /* 
    * 
    * needed for main program 
    * 
    */
   static char message[MAXSIZE];
   int retval;
   static struct sockaddr_in sock_name, sock_name_2;
   int sock_name_2_len;
   struct sockaddr_in sock_dest;
   int sock_dest_len;
   unsigned long remote_addr;
   int msg_len;
   
   if(argc>1)
     grp = argv[1];
   else
     grp = group;

   if(argc>2)
	   dst=argv[2];
   else
	   dst = dest;

   sock = CreateReceiveSocket(&sock_name, port, grp);
   
   sock_dest_len = sock_name_2_len = sizeof(sock_name_2);

   printf("listen on port %i, for %s\n", port, grp);

   // initializing UDP send socket
   remote_addr=inet_addr(dst);
   
   sock_snd = createUDPsocket();
   sock_dest.sin_family=AF_INET;
   sock_dest.sin_port=htons(port);
   sock_dest.sin_addr.s_addr=remote_addr;
   
   if(!sock_snd)
     {
	fprintf(stderr,"Send Socket not created\n");
	return -1;
     }
     
   while(1)
     {
	int count;
	
	memset((void *)message, 0, sizeof(message));
	
	msg_len=retval=recvfrom(sock, 
			message, 
			sizeof(message),
			0,
			(struct sockaddr *) &sock_name_2,
			&sock_name_2_len);
	
	if(retval==-1)
	  {
	     perror("receive");
	     cleanup(sock);
	  }

	retval=sendto(sock_snd,
		      message,
		      msg_len,
		      0,
		      (struct sockaddr *)&sock_dest,
		      sock_dest_len);
	count = 0;
     }
   cleanup(sock);

   return 0;
}
